/*
 * Sample.c
 *
 * main file for Sample
 *
 * This wizard-generated code is based on code adapted from the
 * stationery files distributed as part of the Palm OS SDK 4.0.
 *
 * Copyright (c) 1999-2000 Palm, Inc. or its subsidiaries.
 * All rights reserved.
 */
 
#include <PalmOS.h>
#include <PalmOSGlue.h>

#include "Sample.h"
#include "Sample_Rsc.h"
#include "sqlcli1.h"
#include "sqlcli.h"
#include <stdio.h>
#include <string.h>

/*********************************************************************
 * Entry Points
 *********************************************************************/

/*********************************************************************
 * Global variables
 *********************************************************************/



/*********************************************************************
 * Internal Constants
 *********************************************************************/

/* Define the minimum OS version we support */
#define ourMinVersion    sysMakeROMVersion(3,0,0,sysROMStageDevelopment,0)
#define kPalmOS20Version sysMakeROMVersion(2,0,0,sysROMStageDevelopment,0)

/*********************************************************************
 * Internal Functions
 *********************************************************************/

/*
 * FUNCTION: GetObjectPtr
 *
 * DESCRIPTION:
 *
 * This routine returns a pointer to an object in the current form.
 *
 * PARAMETERS:
 *
 * formId
 *     id of the form to display
 *
 * RETURNED:
 *     address of object as a void pointer
 */

static void * GetObjectPtr(UInt16 objectID)
{
	FormType * frmP;

	frmP = FrmGetActiveForm();
	return FrmGetObjectPtr(frmP, FrmGetObjectIndex(frmP, objectID));
}

/*
 * FUNCTION: MainFormInit
 *
 * DESCRIPTION: This routine initializes the MainForm form.
 *
 * PARAMETERS:
 *
 * frm
 *     pointer to the MainForm form.
 */

#define MAX_STATEMENT_LENGTH 128
static void MainFormInit(FormType *frmP)
{
	FieldType *field;
	const char *wizardDescription;
	char *statusDescription;
	char queryResult[20] = {0};
	UInt16 fieldIndex;
	SQLHANDLE henv, hdbc, hstmt ;
	SQLRETURN rc ;
	char buf[MAX_STATEMENT_LENGTH] = {0};
	SQLINTEGER  empno = 0, selectItem = 0;

	fieldIndex = FrmGetObjectIndex(frmP, MainDescriptionField);
	field = (FieldType *)FrmGetObjectPtr(frmP, fieldIndex);
	FrmSetFocus(frmP, fieldIndex);

	statusDescription = 
	         "#Sample Code Begin....#\n"
	         ;
	FldInsert(field, statusDescription, StrLen(statusDescription));

	rc = SQLAllocEnv(&henv);
    if ( rc != SQL_SUCCESS ) { 
    	statusDescription = 
	         "allocating env handle failed..\n"
	         ;
        FldInsert(field, statusDescription, StrLen(statusDescription));
		goto exit;
	}

	rc = SQLAllocConnect(henv,&hdbc);
    if ( rc != SQL_SUCCESS && rc != SQL_SUCCESS_WITH_INFO) { 
		statusDescription = 
		"allocating myconnection handle failed..\n"
		;
		FldInsert(field, statusDescription, StrLen(statusDescription));
		goto exit;
	}

	rc = SQLConnect((SQLHDBC) hdbc, (SQLTCHAR*) "sample", SQL_NTS, (SQLTCHAR*) "user", SQL_NTS, (SQLTCHAR*) "password", SQL_NTS);
	if (rc!=SQL_SUCCESS && rc != SQL_SUCCESS_WITH_INFO) { 
		statusDescription = 
		"SQLConnect failed..\n"
		;
		FldInsert(field, statusDescription, StrLen(statusDescription));
		goto exit;
	}

    rc = SQLAllocHandle( SQL_HANDLE_STMT, hdbc, &hstmt ) ;
	if (rc!=SQL_SUCCESS && rc != SQL_SUCCESS_WITH_INFO) { 
		statusDescription = 
		"allocating stmt handle failed..\n"
		;
		FldInsert(field, statusDescription, StrLen(statusDescription));
		goto exit;
	}
	
	strcpy(buf,"DROP TABLE employee");
	rc = SQLExecDirect(hstmt,(SQLTCHAR*)buf,SQL_NTS);
	
	strcpy(buf, "CREATE TABLE employee(EMPNO CHAR(10))");
    rc = SQLExecDirect( hstmt, (SQLTCHAR*) buf, SQL_NTS ) ;
	if (rc!=SQL_SUCCESS) { 
		statusDescription = 
		"Creating table employee failed..\n"
		;
		FldInsert(field, statusDescription, StrLen(statusDescription));
		goto exit;
	}
	statusDescription = 
	"Create table: employee....\n"
	;
	FldInsert(field, statusDescription, StrLen(statusDescription));
	
	strcpy(buf, "INSERT INTO employee VALUES('0000000001')");
	rc = SQLExecDirect( hstmt, (SQLTCHAR*) buf, SQL_NTS ) ;
	if (rc!=SQL_SUCCESS  && rc != SQL_SUCCESS_WITH_INFO) { 
		statusDescription = 
		"Inserting into employee failed...\n"
		;
		FldInsert(field, statusDescription, StrLen(statusDescription));
		goto exit;
	}
	statusDescription = "Insert one record into employee\n";
	FldInsert(field, statusDescription, StrLen(statusDescription));
	
	strcpy(buf, "SELECT * FROM employee");
	rc = SQLExecDirect( hstmt, (SQLTCHAR*) buf, SQL_NTS ) ;
	if (rc!=SQL_SUCCESS  && rc != SQL_SUCCESS_WITH_INFO) { 
		statusDescription = "Selecting from employee failed";
		FldInsert(field, statusDescription, StrLen(statusDescription));
		goto exit;
	}

	statusDescription = "*** Query results ***:\n";
	FldInsert(field, statusDescription, StrLen(statusDescription));
	rc = SQLBindCol(hstmt, 1, SQL_C_LONG, (SQLPOINTER) &empno, sizeof(empno), &selectItem);
	
	while ((rc = SQLFetch(hstmt)) == SQL_SUCCESS)
	{
		statusDescription = "EMPNO=" ;
		FldInsert(field, statusDescription, StrLen(statusDescription));
		StrIToA(queryResult,empno);
		FldInsert(field, queryResult, StrLen(queryResult));
		statusDescription = "\n";
		FldInsert(field, statusDescription, StrLen(statusDescription));
	}

	strcpy(buf, "DROP TABLE employee");
	rc = SQLExecDirect(hstmt, (SQLTCHAR*) buf, SQL_NTS);
	if (rc != SQL_SUCCESS && rc != SQL_SUCCESS_WITH_INFO)
	{
		statusDescription = "Drop table employee failed...\n";
		FldInsert(field, statusDescription, StrLen(statusDescription));
		goto exit;
	}
	statusDescription = "Drop table: employee\n";
	FldInsert(field, statusDescription, StrLen(statusDescription));

exit:
	if (hstmt) SQLFreeStmt(hstmt, SQL_DROP);
	if (hdbc) SQLDisconnect(hdbc);
	if (hdbc) SQLFreeConnect(hdbc);
	if (henv) SQLFreeEnv(henv);

	statusDescription = "#Sample Code End....#\n";
	FldInsert(field, statusDescription, StrLen(statusDescription));
	
}

/*
 * FUNCTION: MainFormDoCommand
 *
 * DESCRIPTION: This routine performs the menu command specified.
 *
 * PARAMETERS:
 *
 * command
 *     menu item id
 */

static Boolean MainFormDoCommand(UInt16 command)
{
	Boolean handled = false;

	switch (command)
	{

	}

	return handled;
}

/*
 * FUNCTION: MainFormHandleEvent
 *
 * DESCRIPTION:
 *
 * This routine is the event handler for the "MainForm" of this 
 * application.
 *
 * PARAMETERS:
 *
 * eventP
 *     a pointer to an EventType structure
 *
 * RETURNED:
 *     true if the event was handled and should not be passed to
 *     FrmHandleEvent
 */

static Boolean MainFormHandleEvent(EventType * eventP)
{
	Boolean handled = false;
	FormType * frmP;

	switch (eventP->eType) 
	{
		case menuEvent:
			return MainFormDoCommand(eventP->data.menu.itemID);

		case frmOpenEvent:
			frmP = FrmGetActiveForm();
			FrmDrawForm(frmP);
			MainFormInit(frmP);
			handled = true;
			break;
            
        case frmUpdateEvent:
			/* 
			 * To do any custom drawing here, first call
			 * FrmDrawForm(), then do your drawing, and
			 * then set handled to true. 
			 */
			break;
			
		case ctlSelectEvent:
		{
			if (eventP->data.ctlSelect.controlID == MainClearTextButton)
			{
				/* The "Clear" button was hit. Clear the contents of the field. */
				FieldType * field = (FieldType*)GetObjectPtr(MainDescriptionField);
				if (field)
				{
					FldDelete(field, 0, 0xFFFF);					
					FldDrawField(field);
				}
				break;
			}

			break;
		}
	}
    
	return handled;
}

/*
 * FUNCTION: AppHandleEvent
 *
 * DESCRIPTION: 
 *
 * This routine loads form resources and set the event handler for
 * the form loaded.
 *
 * PARAMETERS:
 *
 * event
 *     a pointer to an EventType structure
 *
 * RETURNED:
 *     true if the event was handled and should not be passed
 *     to a higher level handler.
 */

static Boolean AppHandleEvent(EventType * eventP)
{
	UInt16 formId;
	FormType * frmP;

	if (eventP->eType == frmLoadEvent)
	{
		/* Load the form resource. */
		formId = eventP->data.frmLoad.formID;
		frmP = FrmInitForm(formId);
		FrmSetActiveForm(frmP);

		/* 
		 * Set the event handler for the form.  The handler of the
		 * currently active form is called by FrmHandleEvent each
		 * time is receives an event. 
		 */
		switch (formId)
		{
			case MainForm:
				FrmSetEventHandler(frmP, MainFormHandleEvent);
				break;

		}
		return true;
	}

	return false;
}

/*
 * FUNCTION: AppEventLoop
 *
 * DESCRIPTION: This routine is the event loop for the application.
 */

static void AppEventLoop(void)
{
	UInt16 error;
	EventType event;

	do 
	{
		/* change timeout if you need periodic nilEvents */
		EvtGetEvent(&event, evtWaitForever);

		if (! SysHandleEvent(&event))
		{
			if (! MenuHandleEvent(0, &event, &error))
			{
				if (! AppHandleEvent(&event))
				{
					FrmDispatchEvent(&event);
				}
			}
		}
	} while (event.eType != appStopEvent);
}

/*
 * FUNCTION: AppStart
 *
 * DESCRIPTION:  Get the current application's preferences.
 *
 * RETURNED:
 *     errNone - if nothing went wrong
 */

static Err AppStart(void)
{

	return errNone;
}

/*
 * FUNCTION: AppStop
 *
 * DESCRIPTION: Save the current state of the application.
 */

static void AppStop(void)
{
        
	/* Close all the open forms. */
	FrmCloseAllForms();

}

/*
 * FUNCTION: RomVersionCompatible
 *
 * DESCRIPTION: 
 *
 * This routine checks that a ROM version is meet your minimum 
 * requirement.
 *
 * PARAMETERS:
 *
 * requiredVersion
 *     minimum rom version required
 *     (see sysFtrNumROMVersion in SystemMgr.h for format)
 *
 * launchFlags
 *     flags that indicate if the application UI is initialized
 *     These flags are one of the parameters to your app's PilotMain
 *
 * RETURNED:
 *     error code or zero if ROM version is compatible
 */

static Err RomVersionCompatible(UInt32 requiredVersion, UInt16 launchFlags)
{
	UInt32 romVersion;

	/* See if we're on in minimum required version of the ROM or later. */
	FtrGet(sysFtrCreator, sysFtrNumROMVersion, &romVersion);
	if (romVersion < requiredVersion)
	{
		if ((launchFlags & 
			(sysAppLaunchFlagNewGlobals | sysAppLaunchFlagUIApp)) ==
			(sysAppLaunchFlagNewGlobals | sysAppLaunchFlagUIApp))
		{
			FrmAlert (RomIncompatibleAlert);

			/* Palm OS versions before 2.0 will continuously relaunch this
			 * app unless we switch to another safe one. */
			if (romVersion < kPalmOS20Version)
			{
				AppLaunchWithCommand(
					sysFileCDefaultApp, 
					sysAppLaunchCmdNormalLaunch, NULL);
			}
		}

		return sysErrRomIncompatible;
	}

	return errNone;
}

/*
 * FUNCTION: PilotMain
 *
 * DESCRIPTION: This is the main entry point for the application.
 * 
 * PARAMETERS:
 *
 * cmd
 *     word value specifying the launch code. 
 *
 * cmdPB
 *     pointer to a structure that is associated with the launch code
 *
 * launchFlags
 *     word value providing extra information about the launch.
 *
 * RETURNED:
 *     Result of launch, errNone if all went OK
 */

UInt32 PilotMain(UInt16 cmd, MemPtr cmdPBP, UInt16 launchFlags)
{
	Err error;

	error = RomVersionCompatible (ourMinVersion, launchFlags);
	if (error) return (error);

	switch (cmd)
	{
		case sysAppLaunchCmdNormalLaunch:
			error = AppStart();
			if (error) 
				return error;

			/* 
			 * start application by opening the main form
			 * and then entering the main event loop 
			 */
			FrmGotoForm(MainForm);
			AppEventLoop();

			AppStop();
			break;
	}

	return errNone;
}
